<?php
namespace Required;

use Required\DynamicSyncDataController;
use Smarty;

class DynamicSyncPublicController extends DynamicSyncDataController{
	const slug = 'dynamicsync';
	
	public function __construct(){
		$this->loadSettings();
	}

	public function load(){
		$this->loadSettings();
	}

	public function isApiLoaded(){
		return !empty($this->settings->api_key);
	}

	public function dynamicsync_event_date_id_script($args){
		$atts = shortcode_atts(array(
				'custom_field' => '',
				'hidden_field' => 'inf_custom_EventDateId'
			), $args);

		$urleventdateid = $this->settings->eventDateIdField;

		if(empty($urleventdateid)) {
			$eventDateID = 'Please check DynamicSync plugin settings. Options not set correctly.';
		}

		$this->get_url_params();
		if(!empty($this->urlParameters[$urleventdateid])) {
			$eventDateID = $this->urlParameters[$urleventdateid];
		} else {
			$eventDateID = 'Could not find event date id in URL. Looking for '.$urleventdateid. ' in URL and could not find it. Please make sure that edId={event_date_id} is passed to the registration form.';
		}

		return "<script>
				window.onload = function() {
					document.getElementsByName('".$atts['hidden_field']."')[0].value = '".$eventDateID."'
				}
			  </script>";
	}

	public function dynamicsync_number_guests($args){
		$atts = shortcode_atts(array(
				'max' => 10,
				'status' => 'Confirmed',
				'apikey' => ''
			), $args);
		// get parameteres from URL
		$this->get_url_params();

		// find Event Date ID
		$eventdateid = $this->urlParameters[$this->settings->eventDateIdField];
		$arrFilter = array('field' => "guid", 'filter' => $eventdateid);

		$status = $atts['status'];
		// pull from DynamicSync Data
		if(empty($atts['apikey'])){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $atts['apikey'];
		}

		if($this->load_events($apikey, $status, $reload)) {
			// filter data
			$this->filter_events($this->eventDates, $arrFilter);
			$this->group_events($this->filteredEvents);

			$eventData = $this->eventDates[0];
			var_dump($eventData);
			// get attendee data
			$max_attendees = $eventData['max_attendees'];

			// if max attendee is set
			if(is_numeric($max_attendees)){
				$num_attendees = $eventData['num_attendees'];

				$guests = $max_attendees - $num_attendees - 1;

				ob_start();
				?>
<script>
$(document).ready(function(){
	$('form').submit(function(){
		var guests = $('#inf_custom_NumberofTicketsRequired').val();
		if(isNaN(guests)) guests = 0;

		if(guests > <?php echo $guests ?>){
			alert('Number of guests exceeded');
			return false;
		}
	});
});
</script>
				<?php
				$output = ob_get_contents();
				ob_end_clean();
				return $output;
			}
		}
	}

	public function populate_registration($args){
		$atts = shortcode_atts(array(
				'urleventdateid' => '',
				'hidden_field' => 'inf_custom_EventDateId',
				'firstnamefield' => 'inf_field_FirstName',
				'lastnamefield' => 'inf_field_LastName',
				'emailfield' => 'inf_field_Email',
				'status' => 'Confirmed',
				'apikey' => ''
			), $args);

		// get parameteres from URL
		$this->get_url_params();

		extract($atts);
		if(empty($urleventdateid))
			$urleventdateid = $this->settings->eventDateIdField;

		if(empty($urleventdateid)) {
			$eventdateid = 'Please check DynamicSync plugin settings. Options not set correctly.';
		}
		else
			$eventdateid = $this->urlParameters[$urleventdateid];

		$arrFilter = array("field" => "guid", "filter" => $eventdateid);

		// URL parameter populate into field
		$populateFields = '';
		if(!empty($this->urlParameters[$firstnamefield])) $populateFields .= "jQuery('input[name=inf_field_FirstName]').val('".$this->urlParameters[$firstnamefield]."');\n";
		if(!empty($this->urlParameters[$lastnamefield])) $populateFields .= "jQuery('input[name=inf_field_LastName]').val('".$this->urlParameters[$lastnamefield]."');\n";
		if(!empty($this->urlParameters[$emailfield])) $populateFields .= "jQuery('input[name=inf_field_Email]').val('".$this->urlParameters[$emailfield]."');\n";

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $apikey;
		}

		if($this->load_events($apikey, $status,$reload)) {
			
			// filter data
			$this->filter_events($this->eventDates, $arrFilter);
			$this->group_events($this->filteredEvents);

			$eventData = $this->groupedEvents[0];
			// get attendee data
			$max_attendees = $eventData['max_attendees'];
			// if max attendee is set
			if(is_numeric($max_attendees)){
				$num_attendees = $eventData['num_attendees'];

				$guests = $max_attendees - $num_attendees - 1;

				$isMaxAttendee = "if(guests > ".$guests."){
							alert('Number of guests exceeded');
							return false;
						}";

			}
			$output = "<script>
				jQuery(document).ready(function(){
					document.getElementsByName('".$hidden_field."')[0].value = '".$eventdateid."';

					jQuery('form.infusion-form').submit(function(){
						var guests = jQuery('#inf_custom_NumberofTicketsRequired').val();
						if(isNaN(guests)) guests = 0;
						".$isMaxAttendee."
					});
					".$populateFields."
				});
				</script>";

			return  $output;
		}
	}

	public function dynamicsync_url_parameter($args){
		$atts = shortcode_atts(array(
				'param' => ''
			), $args);

		$this->get_url_params();

		return $this->urlParameters[$atts['param']];
	}

	public function dynamicsync_event_info($params){

		$eArr = shortcode_atts(array(
				'eventid' => '',
				'eventdateid' => '',
				'apikey' => '',
				'urleventid' => '',
				'urleventdateid' => null
			), $params);

		if(in_array("conditionaloutput", $params) || in_array("conditionalOutput", $params)) {
			$condOutput = true;
		} else {
			$condOutput = false;
		}

		if(in_array("issoldout", $params) || in_array("isSoldout", $params) || in_array("isSoldOut", $params)) {
			$isSoldOut = true;
		} else {
			$isSoldOut = false;
		}

		if(empty($params['field']) && !$condOutput && !$isSoldOut) {
			return "Please provide required field name (e.g. field=\"description\")<br>";
		}

		$this->get_url_params();
		$filter = "";
		if(array_key_exists("urleventdateid", $params) || in_array("urleventdateid", $params) || in_array("urlEventDateId", $params)){

			//if(in_array("urleventdateid", $params)) $edId = $params['urleventdateid']
			if(!empty($this->urlParameters[$eArr['urleventdateid']])) {
				$filter = "guid=".$this->urlParameters[$eArr['urleventdateid']];
			}
			else if(!empty($this->urlParameters[$this->settings->eventDateIdField])){

				$filter = "guid=".$this->urlParameters[$this->settings->eventDateIdField];
			}
			else if(!empty($this->urlParameters['inf_custom_EventDateId'])){

				$filter = "guid=".$this->urlParameters['inf_custom_EventDateId'];
			}
		}
		else if(in_array("urleventid", $params) || in_array("urlEventId", $params)){

			//if(in_array("urleventdateid", $params)) $edId = $params['urleventdateid']
			if(!empty($this->urlParameters[$eArr['urleventid']])) {
				$filter = "eventId=".$this->urlParameters[$eArr['urleventid']];
			}
			else
				$filter = "eventId=".$this->urlParameters[$this->settings->eventIdField];
		}
		else if(!empty($eArr['eventid'])) {
			
			$filter = "eventId=".$eArr['eventid'];
		}
		else if(!empty($eArr['eventdateid'])) {
			$filter = "guid=".$eArr['eventdateid'];
		}

		extract($params);
		// Field aliases
		$time = false;
		if($field=="start_time") {
			$field = "start_date";
			$time=true;
		}
		if($field=="end_time") {
			$field = "end_date";
			$time=true;
		}
		if($field=="event_date_id") {
			$field = "guid";
		}
		if($field=="id") {
			$field = "guid";
		}
		if($field=="attendee_limit"){
			$field = "max_attendees";
		}
		if($field=="num_registered_attendees"){
			$field = "num_attendees";
		}
		if($field == "status"){
			$field = "status";
		}
		

		$arrFilter = array();
		if(!empty($filter)) {
			$strFilter = str_replace(' ', '', $filter);
			$expFilter = explode("=", $strFilter);
			$arrFilter = array('field' => $expFilter[0], 'filter' => $expFilter[1]);
		}

		if(empty($noeventstext)) {
			$noeventstext = "";
		}

		if(empty($eventseqno)) {
			$eventseqno = 0;	
		}
		$eventIdArray = array();
		if(!empty($eventid)) {
			$eventid = str_replace(' ', '', $eventid);
			$eventIdArray = explode(",", $eventid);
		}
		
		if(empty($status)) {
			$status = "Confirmed";
		}

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $apikey;
		}

		if($this->load_events($apikey, $status, $reload)) {
			$this->filter_events($this->eventDates, $arrFilter);
			$this->group_events($this->filteredEvents);
			if(is_array($eventIdArray)){
				if(count($eventIdArray) <= 0){
					$event = $this->groupedEvents[$eventseqno];
				}
				else {
					// Event ID has been specified, look for the first date with specified ID
					foreach ($this->groupedEvents as $curEvent) {
						if(in_array($curEvent['eventId'], $eventIdArray)) {
							if($eventseqno==0) {
								$event = $curEvent;
								break;								
							} else {
								$eventseqno--;
							}
						}
					}						
				}
			}
		}

		if(isset($event)) {
			// Output
			if($isSoldOut){
				if($event['soldOut'] == '1')
					return $trueoutput;
				else
					return $falseoutput;
			}

			if(isset($field) || $condOutput) {
				$max_attendees = $event['max_attendees'];
				$num_attendees = $event['num_attendees'];

				if ( empty( $max_attendees ) )	
					$max_attendees = '0';

				if ( empty( $num_attendees ) )
					$num_attendees = '0';

				if ( $field == "max_attendees" ){
					$return = $max_attendees;
					if ( $max_attendees == '0' )
						$return = "Unlimited";
				}

				else if ( $field == "conditionalOutputAttendeesRemaining" ){
					if ( (int) $max_attendees > 0 ){
						$attendees_left = (int) $max_attendees - (int) $num_attendees;

						if ( isset($attendeesremaining) ){
							if ( $attendees_left <= (int) $attendeesremaining)
								$return = $trueoutput;
							else
								$return = $falseoutput;
						}
					}
					else
						$return = $falseoutput;
				}
				else if ( $field == "num_attendees" )
					$return = $num_attendees;
				else if ( $field == "num_remaining_attendees"){
					$attendees_left = (int) $max_attendees - (int) $num_attendees;

					if ( $attendees_left < 0 )
						$attendees_left = 0;
					
					$return = $attendees_left;
					
					if ( $max_attendees == '0' )
						$return = "Unlimited";
				}
				else{
					$return = $event[$field];
					$timezone = $event['timezone'];
				}

			}
			// Check if we should add conditional text
			if($condOutput)
				return $trueoutput;					
	 	} else {
	 		// Event not found
	 		if($condOutput)
	 			return $falseoutput;

	 		if(isset($field))
	 			return $noeventstext;
		}
		// Apply date/time timezone & formatting
		// add confitional for zero (0) result, empty() function considers 0 as empty
		if( !empty($return) || (string) $return == '0' ) {
			// Apply formatting if required
			if($field == 'start_date' || $field == 'end_date') {
				if(!isset($dateformat)) {
					if($time) {
						$dateformat = 'g:i a';
					} else {
						$dateformat = 'l, F j, Y';
					}
				}
				$return = date($dateformat, strtotime($return));
			}
			// Prepend
			if(!empty($prepend)) {
				$return = $prepend.$return;
			}
			// Append
			if(!empty($append)) {
				$return = $return.$append;
			}				
			return $return;
		} 
	}

	public function dynamicsync_event_calendar($args){
		$params = shortcode_atts(array(
				'view' => 'list', //list is a default value
				'group' => 'event',	// By default events will be grouped by event type. Other Options: month
				'status' => 'Confirmed', // By default only confirmed event will be shown
				'eventdateidname' => 'inf_custom_EventDateId',
				'custom' => null,
				'eventid' => '',
				'eventId' => '',
				'fields' => 'title,image,dates,venue_name,venue_address,description,button',
				'dateformat' => '%a, %b %d',
				'timeformat' => 'g:i a',
				'perpage' => 10,
				'dateDescription' => 0,
				'datedescription' => 0,
				'registerFormUrl' => '',
				'registerformurl' => '',
				'eventfullurl' => '',
				'registrationurlfield' => '',
				'registrationUrlField' => '',
				'lowwarningthreshold' => 0,
				'showsoldout' => 1,
				'limit' => '',
				'apikey' => '',
				'sortby' => 'title',
				'soldoutmessage' => null,
				'registerbtn' => null,
				'tbamessage' => 'To be annouced',
				'filter' => '',
				'setlocale' => '',
				'soldoutimageurl' => '',
				'headers' => null,
				'hidefield' => null
			), $args);

		$params = $this->handleEventParams($params);

		if($params['status'] == 'TBA' || $params['status'] == 'tba'){
			$status = 'Tentative';
			if(!isset($params['registerbtn'])) $params['registerbtn'] = 'Keep Me Updated';
			if(in_array($params['view'],array("calendar","full_calendar","Calendar","Full_Calendar"))) $params['view'] = '';
		}
		else
			$status = $params['status'];

		$this->params = $params;
		$eventIdArray = array();
		if(!empty($params['eventid'])) {
			$eventid = str_replace(' ', '', $params['eventid']);
			$eventIdArray = explode(",", $params['eventid']);
		}
		
		if(empty($params['apikey'])){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $params['apikey'];
		}
		
		//
		if($this->load_events($apikey,$status,$reload)){
			if(!empty($params['filter'])){
				$this->filter_events($this->eventDates, $params['arrFilter']);
				$this->group_events($this->filteredEvents);
				$eventDates = $this->groupedEvents;
			}
			else
				$eventDates = $this->eventDates;

			foreach($eventDates as $key=>$event){
				if(is_numeric($params['limit']) && $params['limit'] > 0 && $params['limit'] <= $key) break;
				if(!empty($eventIdArray)) {
					if(in_array($event['eventId'], $eventIdArray)) {
						$event = $this->applyParamsEvent($event);
						$es[] = $event;
					}
				} else {
					$event = $this->applyParamsEvent($event);
					$es[] = $event;
				}
			}
			$eventDates = $es;

			if(isset($eventDates)){
				switch($params['view']){
					case "dates_list":
					case "table":
					case "radio":
					case "custom":
						$events = $eventDates;
						break;
					case "calendar":
					case "full_calendar":
					case "Calendar":
					case "Full_Calendar":
						foreach($eventDates as $event){
							$event['id'] = $event['eventId'];
							$event['start']	= date("Y-m-d H:i", strtotime($event['start_date']));
							$event['end']	= date("Y-m-d H:i", strtotime($event['end_date']));
							$event['time']	= date($params['timeformat'], strtotime($event['start_date']))." - ".date($params['timeformat'], strtotime($event['end_date']));
							$event['textColor'] = "#ffffff";
							$event['soldOutImage'] = $params['soldoutimageurl'];

							if(!empty($eventIdArray)) {
								if(in_array($event['eventId'], $eventIdArray)) {
									$events[] = $event;
								}
							} else {
								$events[] = $event;
							}
						}
						break;
					default:
						$es = $this->events;
						foreach($eventDates as $event) {
							if(!empty($eventIdArray)) {
								if(in_array($event['eventId'], $eventIdArray)) {
									$events[$event['eventId']][] = $event;
								}
							} else {
								$events[$event['eventId']][] = $event;
							}
						}
						break;
				}
			}
		}

		echo "<style>"."\r\n";
		echo $this->getCustomStyle($params['view']);
		echo "\r\n"."</style>"."\r\n";

		switch($params['view']){
			case "calendar":
			case "full_calendar":
			case "Calendar":
			case "Full_Calendar":
				wp_enqueue_script('moment', '//cdnjs.cloudflare.com/ajax/libs/moment.js/2.8.4/moment.min.js', array('jquery'));
				wp_enqueue_script('full_calendar_plugin', '//cdnjs.cloudflare.com/ajax/libs/fullcalendar/2.2.3/fullcalendar.min.js', array('jquery', 'moment'));
				wp_enqueue_style('full_calendar_plugin', '//cdnjs.cloudflare.com/ajax/libs/fullcalendar/2.2.3/fullcalendar.min.css');
				wp_enqueue_style('full_calendar_plugin', '//cdnjs.cloudflare.com/ajax/libs/fullcalendar/2.2.3/fullcalendar.print.css');
				wp_enqueue_script('calendar', plugins_url('../public/js/calendar.js', __FILE__), array('full_calendar_plugin'));
			

				echo '<script> var eventDates = '.json_encode($events).'</script>';
				return "<div id='calendar'></div>";
				break;
			case "dates_list":
				$params = $this->getParams();
				return $this->DatesListTemp($events,$params);
				break;
			case "radio":
				$params = $this->getParams();
				return $this->RadioListTemp($events,$params);
				break;
			case "custom":
				$params = $this->getParams();
				return $this->CustomListTemp($events,$params);
				break;
			case "table":
				// get params from CalendarService
				$params = $this->getParams();

				wp_enqueue_style('dsdev-footable-core-CSS',	plugins_url('../public/css/footable/css/footable.core.css', __FILE__), false );
				wp_enqueue_style('dsdev-main-CSS', plugins_url('../public/css/dynamicsync-main.css', __FILE__),	false );
				wp_enqueue_script('dsdev-footable-JS', plugins_url('../public/js/footable/js/dist/footable.min.js', __FILE__), array('jquery'), null, true);
				wp_enqueue_script('dsdev-footable-main-JS', plugins_url('../public/js/footable/js/footable.main.js', __FILE__), array('jquery', 'dsdev-footable-JS'), null, true);
				wp_enqueue_script('ds-footable-sort-JS', plugins_url('../public/js/footable/js/dist/footable.sort.min.js', __FILE__), array('jquery', 'dsdev-footable-JS'), null, true);
				wp_enqueue_script('ds-footable-pagi-JS',	plugins_url('../public/js/footable/js/dist/footable.paginate.min.js', __FILE__), array('jquery', 'dsdev-footable-JS'), null, true);

				return $this->TableTemp($events, $params);
				break;
			default:
				// get params from CalendarService
				$params = $this->getParams();
				if($params['dateformat'] == '%a, %b %d') $params['dateformat'] = '%A, %B %d, %Y';
				$settings = $this->settings;
				wp_enqueue_script('ds-event-date-JS',	plugins_url('../public/js/event-date.js', __FILE__), array('jquery'), null, true);

				return $this->eventDateTemp($events, $params, $settings);
				break;
		}
	}

	public function dynamicsync_event_info_template($atts){
		ob_start();
		$params = shortcode_atts(array(
				'status' => 'Confirmed', // By default only confirmed event will be shown
				'eventid' => '',
				'dateformat' => 'D, M j',
				'timeformat' => 'h:i a',
				'registerFormUrl' => '',
				'registerformurl' => '',
				'eventfullurl' => '',
				'iteration' => '',
				'fields' => '',
				'templatefile' => null,
				'template' => null,
				'noeventtemplatefile' => null,
				'noeventtemplate' => null,
				'eventseqno' => 0,
				'eventlimit' => 0,
				'registerbtn' => 'Register',
				'apikey' => ''
			), $atts);

		$smarty = new Smarty();
		// Get event data from API if we don't have it already
		$params = $this->handleEventParams($params);
		
		$this->params = $params;
		
		extract($params);

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $apikey;
		}

		if($iteration == '1' && $this->load_events($apikey,$status,$reload)){
			if(!empty($eventid)) {
				$this->select_events($eventid);
			}
			$events = $this->eventDates;

			if(empty($fields)){
				$orderFields = array("title","user1","date","venue_name");
			}
			else
				$orderFields = explode(",",$fields);

			$newevents == array();
			foreach($events as $key=>$event){
				if(!$eventlimit || $key <= $eventlimit){ 
					//$event = $this->applyParamsEvent($event);
					$event['event_date_id'] = $event['guid'];
					$event['id'] = $event['guid'];
					$event['start_time'] 	= date('g:i a', 	strtotime($event['start_date']) );
					$event['end_time'] 		= date('g:i a', 	strtotime($event['end_date']) );
					$event['start_date'] 	= date('l, F j, Y', strtotime($event['start_date']));
					$event['end_date'] 		= date('l, F j, Y', strtotime($event['end_date']));
					$event['attendee_limit'] = $event['max_attendees'];
					$event['num_registered_attendees'] = $event['num_attendees'];
					$newevents[$key] = $event;
				}
			}
			$smarty->assign("events",$newevents);
			$smarty->assign("orderFields",$orderFields);
			$smarty->assign("registerbtn",$registerbtn);
			// Event field aliases
			if(!empty($templatefile)) {
				if(file_exists($templatefile)) {
					$smarty->display($templatefile);
				} else {
					echo 'Template file: '.$templatefile. ' not found.';
				}						
			}
			else if(isset($template)) {
				$smarty->display('eval:'.$template);						
			}
			else {
				$plugin_folder = substr(dirname(plugin_basename(__FILE__)),0,strpos(dirname(plugin_basename(__FILE__)),"/"));
				$smarty->display("wp-content/plugins/".$plugin_folder."/templates/iteration-template.tpl");
			}
		} else if($event = $this->findEvent($atts)) {
			$smarty->assign($event);
			$smarty->assign('event_date_id',$event['guid']);
			$smarty->assign('id', $event['guid']);
			$smarty->assign('start_time', date('g:i a', strtotime($event['start_date'])));
			$smarty->assign('end_time', date('g:i a', strtotime($event['end_date'])));
			$smarty->assign('start_date', date('l, F j, Y', strtotime($event['start_date'])));
			$smarty->assign('end_date', date('l, F j, Y', strtotime($event['end_date'])));
			$smarty->assign('attendee_limit', $event['max_attendees']);
			$smarty->assign('num_registered_attendees', $event['num_attendees']);
			if(isset($templatefile)) {
				if(file_exists($templatefile)) {
					$smarty->display($templatefile);
				} else {
					echo 'Template file: '.$templatefile. ' not found.';
				}						
			}
			if(isset($template)) {
				$smarty->display('eval:'.$template);
			}
			if(!isset($template) && !isset($templatefile)) {				
				echo "Please specify with template or template file.";
			}
		} else {
			// Event Not Found
			if(isset($noeventtemplatefile)) {
				if(file_exists($noeventtemplatefile)) {
					$smarty->display($noeventtemplatefile);
				} else {
					echo 'Template file: '.$noeventtemplatefile. ' not found.';
				}						
			}
			if(isset($noeventtemplate)) {
				$smarty->display('eval:'.$noeventtemplate);
			}
		}
		$output = ob_get_clean();
		return $output;	
	}

	public function dynamicsync_venue_map($args){
		$atts = shortcode_atts(
				array(
					'eventid' => '',
					'eventdateid' => '',
					'eventseqno' => '',
					'urleventdateid' => '',
					'width' => '100%',
					'height' => '350',
					'apikey' => '',
					'status' => 'Confirmed'
				), $args 
			);
				
		//init vars
		$eventID 		= $atts['eventid'];
		$eventDateID 	= $atts['eventdateid'];
		$eventSeqNo 	= $atts['eventseqno'];
		$mapWidth 		= $atts['width'];
		$mapHeight 		= $atts['height'];
		
		//event id and event date id has not been spcified on the shortcode, check in the URL
		if( empty($eventID) && empty( $eventDateID ) )
		{
			$this->get_url_params();
				
			if(array_key_exists("urleventdateid", $atts)) {
				if(!empty($atts['urleventdateid'])) {
					$urleventdateid = $atts['urleventdateid'];
				} else if(!empty($this->urlParameters['inf_custom_EventDateId'])) {
					$urleventdateid = 'inf_custom_EventDateId';
				} else {
					$urleventdateid = $this->settings->eventDateIdField;
				}
								
				if(!empty($this->urlParameters[$urleventdateid])) {
					$eventDateID = $this->urlParameters[$urleventdateid];
				}					
			}

			if(array_key_exists("urleventid", $atts)) {	
				$urleventid = $this->settings->eventIdField;
				
				if(!empty($this->urlParameters[$urleventid])) {
					$eventID = $this->urlParameters[$urleventid];
				}
			}
		}

		//check if has event ids
		if( empty($eventID) && empty( $eventDateID ) )
		{
			return 'Event ID or Event Date ID not specified or Cannot find on the URL.';
		}
		
			
		$eventDates = array();
		$eventDateData = array();
		
		
		if ( empty( $eventSeqNo ) )
			$eventSeqNo = 0;
		else
			$eventSeqNo = (int)$eventSeqNo;
		
		// Get shortcode attributes
		if(!empty($atts)) {
			extract($atts);
		}

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $apikey;
		}
	
		// Get event data from API if we don't have it already
		$eventDatesLoaded = $this->load_events($apikey,$status,$reload);
		
		if( $eventDatesLoaded ){
			$this->group_events($this->eventDates);
			
			//Limit the data to be pass on to the javascript code. 
			//This will prevent sensitive information from getting printed on the JS Code (such as email or phone number)
			$whitelist = array(
				'guid',
				'eventId',
				'title',
				'description',
				'venue_name',
				'venue_address',
				'contact_person',
				'start_date',
				'end_date',
				'timezone',
			);
			
			//if only event id has been specified
			if ( !empty($eventID) && empty($eventDateID) )
			{
				// Event ID has been specified, process only event dates that belongs to the event ids
				foreach ($this->groupedEvents as $currentEvent)
				{
					//Check if event id exists
					if( $currentEvent['eventId'] == $eventID )
					{
						$filtered = array_intersect_key( $currentEvent, array_flip( $whitelist ) );
						$eventDates[] = $filtered;
					}
				}
				
				//get the event date based on the event sequence number specified
				$eventDateData = $eventDates[$eventSeqNo];
				
			}
			else if ( empty($eventID) && !empty($eventDateID) )
			{
				// Event Date ID has been specified, get only the event that has the specified event date id
				foreach ($this->groupedEvents as $currentEvent)
				{
					//Check if event date id exists
					if( $currentEvent['guid'] == $eventDateID )
					{
						$filtered = array_intersect_key( $currentEvent, array_flip( $whitelist ) );
						
						//get the event date found
						$eventDateData = $filtered;
						
						break;
					}
				}
			}
			else
				return false;
			
							
		}

		$output = '<script type="text/javascript">'. "\r\n";
		$output.= 'jQuery( document ).ready( function() {'. "\r\n";					
		$output.= 'var jsonEventDate = "'. addslashes(json_encode( $eventDateData )). '";' . "\r\n";
		$output.= 'jsonEventDate = jQuery.parseJSON(jsonEventDate);'. "\r\n";
		$output.= 'var tmp = JSON.stringify(jsonEventDate, function(key, value) {'. "\r\n";
		$output.= 'if(value == null) return "";'. "\r\n";
		$output.= 'return value;'. "\r\n";
		$output.= '});'. "\r\n";
		$output.= 'jsonEventDate = jQuery.parseJSON(tmp);'. "\r\n";
		$output.= "var embedMap ='<iframe width=\"".$mapWidth."\" height=\"".$mapHeight."\" frameborder=\"0\" scrolling=\"no\" marginheight=\"0\" marginwidth=\"0\" src=\"https://maps.google.com/maps?&amp;q='+ encodeURIComponent( jsonEventDate.venue_address ) +'&amp;output=embed\"></iframe>';". "\r\n";
        $output.= 'jQuery("#'.self::slug.'_venue_map").html(embedMap);'. "\r\n";
		$output.= '});'. "\r\n";
		$output.= '</script>'. "\r\n";
		
		//Display the map continer for the JS to use.
		$output.= '<div class="'.self::slug.'-venue-map-container"><div id="'.self::slug.'_venue_map"></div></div>'. "\r\n";

		return $output;
	}



	public function dropdown_select($args){
		$params = shortcode_atts(
			array(
				'eventid' 				=> '',
				'eventdateid'			=> '',
				'eventseqno' 			=> '',
				'urleventid' 			=> '',
				'urleventdateid' 		=> '',
				'eventdateidfieldname' 	=> 'inf_custom_EventDateId',
				'evendateidfieldname' 	=> 'inf_custom_EventDateId',
				'formid' 				=> '',
				'containerid' 			=> '',
				'label' 				=> 'start_date',
				'datetimeformat'		=> 'D, M j, h:i a',
				'separator' 			=> ' - ',
				'max_events'			=> '0',
				'max_days' 				=> '0',
				'max_months' 			=> '0',
				'apikey' 				=> '',
				'status'				=> 'Confirmed',
				'selector'				=> '',
				'nonselect' 			=> ''
			), $args);
				
		//init vars
		$eventID 				= $params['eventid'];
		$eventDateID 			= $params['eventdateid'];
		$eventSeqNo 			= $params['eventseqno'];
		$eventDateIDFieldName 	= $params['eventdateidfieldname'];
		$evenDateIDFieldName 	= $params['evendateidfieldname'];
		$eventFormID 			= $params['formid'];
		$eventContainerID 		= $params['containerid'];
		$labelOption 			= $params['label'];
		$dateTimeFormat 		= $params['datetimeformat'];
		$separator 				= $params['separator'];
		$max_events 			= (int)$params['max_events'];
		$max_days 				= (int)$params['max_days'];
		$max_months 			= (int)$params['max_months'];
		$nonselect 				= $params['nonselect'];
		$selector 				= $params['selector'];

		// to correct mispelling :P
		if($eventDateIDFieldName != $evenDateIDFieldName) $evenDateIDFieldName = $eventDateIDFieldName;
		
		//event id and event date id has not been spcified on the shortcode, check in the URL
		if( empty($eventID) && empty( $eventDateID ) ){
			$this->get_url_params();
			
			if(array_key_exists("urleventdateid", $params)) {
				if(!empty($params['urleventdateid']))
					$urleventdateid = $params['urleventdateid'];
				else
					$urleventdateid = $this->settings->eventDateIdField;
								
				if(!empty($this->urlParameters[$urleventdateid]))
					$eventDateID = $this->urlParameters[$urleventdateid];
			}

			if(array_key_exists("urleventid", $params)) {

				$urleventid = $this->settings->eventIdField;
				
				if(!empty($this->urlParameters[$urleventid]))
					$eventID = $this->urlParameters[$urleventid];
				$eventDateID = "";
			}

		}

		//check if has event ids
		if( empty($eventID) && empty( $eventDateID ) ){

			return 'Event ID or Event Date ID not specified or Cannot find on the URL.';
		}
		
		$eventDates = array();
		$eventDateData = array();
		
		if ( empty( $eventSeqNo ) )
			$eventSeqNo = 0;
		else
			$eventSeqNo = (int)$eventSeqNo;
		
		// Get shortcode attributes
		if(!empty($params))
			extract($params);

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
		}
		// Get event data from API if we don't have it already
		$eventDatesLoaded = $this->load_events($apikey,$status,$reload);
		if( $eventDatesLoaded ){

			$this->group_events($this->eventDates);
				
			//if only event id has been specified
			if ( !empty($eventID) && empty($eventDateID)){
				//get list of event ids
				$eventArray = explode(',', $eventID);

				// Event ID has been specified, process only event dates that belongs to the event ids
				foreach ($this->groupedEvents as $currentEvent){
					//Check if event id exists
					if( in_array($currentEvent['eventId'], $eventArray) )
						$eventDates[] = $currentEvent;
				}
				//get the event dates
				$eventDateData = $eventDates;
			}
			else if ( (empty($eventID) && !empty($eventDateID)) || (!empty($eventID) && !empty($eventDateID)) ){
				//get list of event date ids
				$eventDateArray = explode(',', $eventDateID);
				
				// Event Date ID has been specified, get only the event that has the specified event date id
				foreach ($this->groupedEvents as $currentEvent){
					//Check if event date id exists
					if( in_array($currentEvent['guid'], $eventDateArray) ){
						//get the event date found
						$eventDateData[] = $currentEvent;
						break;
					}
				}
			}
			else
				return false;
		}

		//filter out event dates for days/months
		if ( $max_days > 0 || $max_months > 0 ){
			$tmpArray = $eventDateData;
			$newEventDateData = array();

			foreach($tmpArray as $events){
				if ( ($max_months >= 0 && $max_days == 0) ){
					if (strtotime($events['start_date']) < strtotime('+'.$max_months.' months', time()))
						$newEventDateData[] = $events;
				}
				elseif ( $max_months == 0 && $max_days >= 0 ){
					if (strtotime($events['start_date']) < strtotime('+'.$max_days.' days', time()))
						$newEventDateData[] = $events;
				}
			}
			//set the new event date data
			$eventDateData = $newEventDateData;
		}
			
		// Filter sold out events
		$tempEvents = array();
		foreach($eventDateData as $event) {
			if(!$event['soldOut']) {
				$tempEvents[] = $event;
			}
		}
		$eventDateData = $tempEvents;
		
		$labelOptionArray = explode(',', $labelOption);
		$dropdownOptions = '';
		$eventCtr = 0;

		if(!empty($nonselect)) $dropdownOptions = '<option>'.$nonselect.'</option>';

		foreach( $eventDateData as $events ){
			//check if we've reached the maximun allowed number of event dates
			if($eventCtr >= $max_events && $max_events > 0)
				break;
			
			$ctr = 0;
			$combinedLabel = '';

			foreach( $labelOptionArray as $labels ){
				$labels = trim($labels);
				if ( array_key_exists($labels, $events) ){
					$ctr++;
					
					if ( 'start_date' == $labels || 'end_date' == $labels ){
						$timezone = $events['timezone'];
						$tmp = date($dateTimeFormat, strtotime($events[$labels]));
						$combinedLabel .= $tmp;
					}
					else
						$combinedLabel .= $events[$labels];

					//check if not last item then add the separator
					if ( $ctr < count($labelOptionArray) )
						$combinedLabel .= $separator;
				}
			}
			$selected = "";
			if(!empty($selector)){
				if(!empty($this->urlParameters[$selector]) && $events['guid'] == $this->urlParameters[$selector]){
					$selected = " selected";
				}
			}
			$dropdownOptions .= '<option value="'.$events['guid'].'" '.$selected.'>'.$combinedLabel.'</option>';
			$eventCtr++;
		}
		
		if ( empty($dropdownOptions) && empty($nonselect) )
			$dropdownOptions .= '<option value="">- No Event dates found -</option>';
		
		// find way to group js at the bottom
		return '<script type="text/javascript">
			window.onload = function(){
				try{
					var objSelect = jQuery(".dyamicsync_dropdown");
					objSelect.attr("onchange", "onChangeDropDownBox(this,this.value)");
					for(var i = 0; i < objSelect.length; i++){
						onChangeDropDownBox(objSelect[i]);
					}
				} catch( Err ){
					console.log(Err.message);
				}
			}
			function onChangeDropDownBox(e){
				try{
					var formObj = e.closest("form");
					jQuery(formObj).find("input[name=\''.$evenDateIDFieldName.'\']").val(e.value);
				} catch( Err ){
					console.log(Err.message);
				}
			}
		</script><select id="dynamicsync_dropdown_select" class="dyamicsync_dropdown">'.$dropdownOptions.'</select>';
	}

	public function date_selector($atts){
		// Attributes
		$atts = shortcode_atts(
			array(
				'eventid'				=> '',
				'evendateidfieldname' 	=> 'inf_custom_EventDateId',
				'eventdatepickerfieldid'=> 'inf_custom_EventDate1',
				'formid' 				=> '',
				'containerid' 			=> '',
				'apikey' 				=> '',
				'status' 				=> 'Confirmed'
			), $atts 
		);
		
		//init vars
		$eventID 				= $atts['eventid'];
		$evenDateIDFieldName 	= $atts['evendateidfieldname'];
		$eventDatePickerFieldID = $atts['eventdatepickerfieldid'];
		$eventFormID 			= $atts['formid'];
		$eventContainerID 		= $atts['containerid'];
		
		$eventIdArray = array();
		$eventDates = array();
		
		//check if has event ids
		if( !empty($eventID) ){
			$tmp = str_replace(' ', '', $eventID);
			$eventIdArray = explode(",", $tmp);
		}
	
		// Get shortcode attributes
		if(!empty($atts))
			extract($atts);

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $apikey;
		}
		// Get event data from API if we don't have it already
		$eventDatesLoaded = $this->load_events($apikey,$status,$reload);
		
		if( $eventDatesLoaded ){
			$this->group_events($this->eventDates);
			//self::write_log( print_r( $this->groupedEvents, true ) );
			//Limit the data to be pass on to the javascript code. 
			//This will prevent sensitive information from getting printed on the JS Code (such as email or phone number)
			$whitelist = array(
				'guid',
				'eventId',
				'title',
				'venue_name',
				'start_date',
				'timezone',
			);

			if(count($eventIdArray) <= 0){
				//No Event IDs has been specified, process all event dates
				foreach ($this->groupedEvents as $currentEvent){
					$filtered = array_intersect_key( $currentEvent, array_flip( $whitelist ) );
					$eventDates[] = $filtered;
				}
			}
			else{
				// Event ID has been specified, process only event dates that belongs to the event ids
				foreach ($this->groupedEvents as $currentEvent){
					//Check if event ids exists
					if( in_array($currentEvent['eventId'], $eventIdArray) ){
						$filtered = array_intersect_key( $currentEvent, array_flip( $whitelist ) );
						$eventDates[] = $filtered;
					}
				}						
			}
		}

		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-ui-datepicker');
		
		wp_enqueue_style('ds-jquery-ui-core', plugins_url('../public/js/jquery-ui/jquery-ui.css', __FILE__), false );
		wp_enqueue_style('ds-jquery-ui-structure', plugins_url('../public/js/jquery-ui/jquery-ui.structure.css', __FILE__), false );
		wp_enqueue_style('ds-dsync-jquery-ui-theme', plugins_url('../public/js/jquery-ui/jquery-ui.theme.css', __FILE__), false );

		ob_start();

		?>
			<script type="text/javascript">
				var sort_by = function(field, reverse, primer){

				   var key = primer ? 
					   function(x) {return primer(x[field])} : 
					   function(x) {return x[field]};

				   reverse = !reverse ? 1 : -1;

				   return function (a, b) {
					   return a = key(a), b = key(b), reverse * ((a > b) - (b > a));
					 } 
				}

				jQuery( document ).ready( function() {
				<?php
					
					//get form id
					if ( !empty($eventFormID) )
						$elemID = '#'.$eventFormID . ' ';
					else
						$elemID = '';
						
					//get datepicker container id
					if ( !empty($eventContainerID) )
						$elemID2 = '#'.$eventContainerID . ' #';
					else
						$elemID2 = '#';

					//prepare jQuery object for Event Date ID hidden field
					echo 'var evenDateIDFieldName = jQuery(\''.$elemID.'[name="'.$evenDateIDFieldName.'"]\');' . "\r\n";
					//prepare jQuery object for the Datepicker's field
					echo 'var eventDatePickerFieldID = jQuery(\''.$elemID2.$eventDatePickerFieldID.'\');' . "\r\n";
					//prepeare the json data containing the event dates
					echo 'var jsonDates = "'. addslashes(json_encode( $eventDates )). '";' . "\r\n";
				?>
					//check if eventDatePickerFieldID exists
					if ( jQuery(eventDatePickerFieldID).length > 0 )
					{
						//convert json string to json object
						jsonDates = jQuery.parseJSON(jsonDates);
						
						//sort dates in reverse order, just in case the dates are not sorted by date
						jsonDates = jsonDates.sort(function(a,b) {
										return new Date(b.start_date).getTime() - new Date(a.start_date).getTime();
									});
														
						//holds formatted date to be used for comparing dates in enabling/disabling dates on datepicker
						var avaialableDates = new Array();
						
						avaialableDates = setupDates(jsonDates);
						
						//enable only existing event dates (confirmed)
						jQuery(eventDatePickerFieldID).datepicker({
							beforeShowDay: function(date){
								var string = jQuery.datepicker.formatDate('yy-mm-dd', date);
								
								//check if current date exists in avaialableDates, return true if found.
								return [ avaialableDates.indexOf(string) != -1 ];
							}
						});
						
						//On change date event
						jQuery(eventDatePickerFieldID).on('change', function() {
							
							//format selected date
							var selectedDate = jQuery.datepicker.formatDate('yy-mm-dd', new Date( jQuery(this).val() ));
							
							//check if valid date
							if ( selectedDate != 'NaN-NaN-NaN')
							{
								//loop through event dates to search for the first occurance of the selected date
								for ( a in jsonDates )
								{
									//format date
									var formattedDate = jQuery.datepicker.formatDate('yy-mm-dd', new Date( jsonDates[a].start_date ));
									
									//check if selected date exists in avaialable dates
									if ( selectedDate == formattedDate )
									{
										//set the event date ID to event date id field
										jQuery(evenDateIDFieldName).val(jsonDates[a].guid);
										break;
									}
								}
							}
						});
						
						//Every five seconds, update the date selector disabled/enabled dates.
						var dsMonitorTime = setInterval( function() {
						
							//holds formatted date to be used for comparing dates in enabling/disabling dates on datepicker
							var avaialableDatesUpdate = new Array();
							
							avaialableDatesUpdate = setupDates(jsonDates);
							
							//check if there are changes with the available events
							if ( avaialableDatesUpdate.toString() != avaialableDates.toString() )
							{
								//Update jQuery Datepicker
								//Enable only existing event dates (confirmed)
								jQuery(eventDatePickerFieldID).datepicker(
									"option",
									"beforeShowDay",
									function(date){
										var string = jQuery.datepicker.formatDate('yy-mm-dd', date);
										
										//check if current date exists in avaialableDates, return true if found.
										return [ avaialableDatesUpdate.indexOf(string) != -1 ];
									}
								);
								
								//Update the latest available dates
								avaialableDates = avaialableDatesUpdate;
									
								//Reshow datepicker if currently shown
								if ( jQuery(eventDatePickerFieldID).datepicker( "widget" ).is(":visible") == true )
								{
									jQuery(eventDatePickerFieldID).datepicker( "show" );
								}
							}
								
						}, 5000);
					
					}
					
					function setupDates( json_date )
					{
						var jsonDates = json_date;
						var avaialableDates = new Array();
						var sameDateCounter = 0;
						
						//Get today's date and time based on UTC
						var currentDateTime = new Date().getTime() / 1000;
														
						//loop through event dates, format each date and push to avaialableDates to prepare comparison in enabling/disabling dates on datepicker
						for ( d in jsonDates )
						{
							var timeZone = jsonDates[d].timezone;
							if ( timeZone == null || timeZone == undefined )
								timeZone = 0;
									
							//convert start date to UTC and apply timezone offset
							var startDate = ((new Date( jsonDates[d].start_date ).getTime()) + (timeZone*60*60*1000)) / 1000;
							
							if ( d < jsonDates.length - 1)
							{
							
								var st1 = jQuery.datepicker.formatDate('yy-mm-dd', new Date(jsonDates[d].start_date));
								var st2 = jQuery.datepicker.formatDate('yy-mm-dd', new Date(jsonDates[parseInt(d) + 1].start_date));
								
								if ( st1 == st2 )
								{
									sameDateCounter++;

									//skip item if dates are the same after the first comparison
									if ( sameDateCounter > 1 )
										continue;
								}
								else
								{
									//check if previos item is the same as the current item
									if ( d > 0 )
									{
										var st3 = jQuery.datepicker.formatDate('yy-mm-dd', new Date(jsonDates[parseInt(d) - 1].start_date));
										var st4 = jQuery.datepicker.formatDate('yy-mm-dd', new Date(jsonDates[d].start_date));
										
										//skip item if dates are the same after the first comparison
										if ( st3 == st4 )
											continue;
									}
										
									//dates are not the same anymore, reset counter
									sameDateCounter = 0;
								}
							}
							
							if ( currentDateTime < startDate )
							{
								//add the event dates
								avaialableDates.push(jQuery.datepicker.formatDate('yy-mm-dd', new Date(jsonDates[d].start_date)));
							}
						}
						
						return avaialableDates;
					}
				});
			</script>
		<?php
		$output = ob_get_contents();
		ob_end_clean();
		return $output;
	}

	public function getParams(){
		return $this->params;
	}

	public function getCustomStyle($view){
		// in the future gonna have separate CSS for event calendar
		$output = "";
		switch($view){
			case "calendar":
			case "full_calendar":
			case "Calendar":
			case "Full_Calendar":
				$output = $this->settings->fullCalendarCSSField;
				break;
			case "dates_list":
				$output = $this->settings->datesListCSSField;
				break;
			case "table":
				$output = $this->settings->tableCSSField;
				break;
			case "custom":
				$output = $this->settings->customCSSField;
				break;
			default:
				$output = $this->settings->eventDatesListCSSField;
				break;
		}
		return $output;
	}

	public function dynamicsync_add_to_calendar($args)
	{				
		// Attributes
		$atts = shortcode_atts(
			array(
				'eventid' => '',
				'eventdateid' => '',
				'eventseqno' => '',
				'urleventdateid' => '',
				'apikey' => '',
				'status' => 'Confirmed'
			), $args 
		);
				
		//init vars
		$eventID = $atts['eventid'];
		$eventDateID = $atts['eventdateid'];
		$eventSeqNo = $atts['eventseqno'];
		
		//event id and event date id has not been spcified on the shortcode, check in the URL
		if( empty($eventID) && empty( $eventDateID ) )
		{
			$this->get_url_params();

			if(array_key_exists("urleventdateid", $atts)) {
				if(!empty($atts['urleventdateid'])) {
					$urleventdateid = $atts['urleventdateid'];
				} else {
					$urleventdateid = $this->settings->eventDateIdField;
				}

				if(!empty($this->urlParameters[$urleventdateid])) {
					$eventDateID = $this->urlParameters[$urleventdateid];
				}					
			}

			if(array_key_exists("urleventid", $atts)) {	
				$urleventid = $this->settings->eventIdField;
				
				if(!empty($this->urlParameters[$urleventid])) {
					$eventID = $this->urlParameters[$urleventid];
				}
			}
		}

		//check if has event ids
		if( empty($eventID) && empty( $eventDateID ) ){
			return 'Event ID or Event Date ID not specified or Cannot find on the URL.';
		}
		
		$eventDates = array();
		$eventDateData = array();
		
		
		if ( empty( $eventSeqNo ) )
			$eventSeqNo = 0;
		else
			$eventSeqNo = (int)$eventSeqNo;
		
		// Get shortcode attributes
		if(!empty($atts)) {
			extract($atts);
		}

		if(empty($apikey)){
			$reload = false;
			$apikey = $this->settings->api_key;
		}
		else{
			$reload = true;
			$apikey = $apikey;
		}
		// Get event data from API if we don't have it already
		if($this->load_events($apikey,$status,$reload)){
			$this->group_events($this->eventDates);
			
			//Limit the data to be pass on to the javascript code. 
			//This will prevent sensitive information from getting printed on the JS Code (such as email or phone number)
			$whitelist = array(
				'guid',
				'eventId',
				'title',
				'description',
				'venue_name',
				'venue_address',
				'contact_person',
				'start_date',
				'end_date',
				'timezone',
			);
			
			//if only event id has been specified
			if ( !empty($eventID) && empty($eventDateID) ){
				// Event ID has been specified, process only event dates that belongs to the event ids
				foreach ($this->groupedEvents as $currentEvent){
					//Check if event id exists
					if( $currentEvent['eventId'] == $eventID ){
						$filtered = array_intersect_key( $currentEvent, array_flip( $whitelist ) );
						$eventDates[] = $filtered;
					}
				}
				
				//get the event date based on the event sequence number specified
				$eventDateData = $eventDates[$eventSeqNo];
			}
			else if ( empty($eventID) && !empty($eventDateID) ){
				// Event Date ID has been specified, get only the event that has the specified event date id
				foreach ($this->groupedEvents as $currentEvent){
					//Check if event date id exists
					if( $currentEvent['guid'] == $eventDateID ){
						$filtered = array_intersect_key( $currentEvent, array_flip( $whitelist ) );

						//get the event date found
						$eventDateData = $filtered;						
						break;
					}
				}
			}
			else
				return false;
		}
		// fix!!!
		$eventDateData['start_date'] = date("Y-m-d H:i", strtotime($eventDateData['start_date']) - ($eventDateData['timezone'] * 60 * 60));
		$eventDateData['end_date'] = date("Y-m-d H:i", strtotime($eventDateData['end_date']) - ($eventDateData['timezone'] * 60 * 60));

		wp_enqueue_style('ds-add-to-cal-main-css', plugins_url('../public/js/addcalevent/AddCalEvent.css', __FILE__), false );
		wp_enqueue_script('ds-add-to-cal-main-js', plugins_url('../public/js/addcalevent/AddCalEvent.js', __FILE__), array('jquery'), null, true);
		wp_enqueue_script('ds-add-to-cal-zone-js', plugins_url('../public/js/addcalevent/AddCalEventZones.js', __FILE__), array('jquery'), null, true);

		//GENERATE THE JAVASCRIPT CODE TO PUT ON FOOTER VIA wp_footer ACTION HOOK
		ob_start();
		?>
			<style type="text/css">
				.dynamicsync-add-to-cal{
					text-align: center;
				}
				.dynamicsync-add-to-cal-button{
					border: 1px solid #aaa;
					padding: 10px;
					cursor: pointer;
				}
			</style>
			<script type="text/javascript">
				jQuery( document ).ready( function() {
				<?php					
					//prepeare the json data containing the event date details
					echo 'var jsonEventDate = "'. addslashes(json_encode( $eventDateData )). '";' . "\r\n";
				?>
					//convert JSON string to JSON object
					jsonEventDate = jQuery.parseJSON(jsonEventDate);
					
					//convert to string and replace null with empty string
					var tmp = JSON.stringify(jsonEventDate, function(key, value) {
						// if value is null, return "" as a replacement
						if(value == null)
							return "";

						// otherwise, leave the value unchanged
						return value;
					});
					
					//convert back to JSON object
					jsonEventDate = jQuery.parseJSON(tmp);
							
					//get the timezone
					var tz = jsonEventDate.timezone;
					
					if ( tz == '' )
						tz = 0;
					
					/**
						Convert the timezone to: +/-HH:MM format
					**/
					if ( tz.indexOf('.') > 0 ){
						//hours
						var tzH = tz.substring(0, tz.indexOf('.') - 1);
						
						//minutes
						var tzM = tz.substring(tz.indexOf('.') + 1);
												
						if ( parseInt(tzH) < 10 && parseInt(tzH) > -10 ){
							var sign = '+';
							
							if ( parseInt(tzH) < 0 ){
								//get the negative
								sign = tzH.substring(0, 1);
							}
							tzH = sign + '0' + tzH;
						}
						tz = tzH + ':' + tzM;
					}
					else{
						var tzH = tz;
						
						if ( parseInt(tzH) < 10 && parseInt(tzH) > -10 ){
							var sign = '+';
							
							if ( parseInt(tzH) < 0 ){
								//get the negative
								sign = tzH.substring(0, 1);
							}
							
							tzH = sign + '0' + tzH;
						}
							
						tz = tzH + ':00';
					}
											
					var data_options = {
							'onclick': true,
							'apps': [],
							'data': {
								"title": jsonEventDate.title,
								"desc": jsonEventDate.description, 
								"location": jsonEventDate.venue_address,
								"url": "", // only available in Yahoo calendars
								"organizer": {     // only available in Outlook
									"name": jsonEventDate.contact_person,
									"email": ""
								},
								"time":{
									"start": jsonEventDate.start_date,
									"end": jsonEventDate.end_date,
									"zone": tz
								},
							},
							'ics': '<?php echo plugins_url('../public/ics/download.php', __FILE__); ?>'
						};
						
					jQuery("#<?php echo self::slug.'-add-to-cal-button-'.$eventDateData['guid'] ?>").addcalevent( data_options );

				});
			</script>
		<?php
		$output = ob_get_contents();
		ob_end_clean();

		//pass the JS code to dsync_add_to_calendar_js_script
		
		
		//print button
		return $output."\n\r".'<div class="'.self::slug.'-add-to-cal"><a class="ace_btn '.self::slug.'-add-to-cal-button" id="'.self::slug.'-add-to-cal-button-'.$eventDateData['guid'].'">Add to Calendar</a></div>';
	}

	private function CustomListTemp($events,$params){
		$output = "";
		$smarty = new Smarty();
		$newevents == array();
		$eventlimit = 0;
		foreach($events as $key=>$event){
			if(!$eventlimit || $key <= $eventlimit){ 
				//$event = $this->applyParamsEvent($event);
				$event['event_date_id'] = $event['guid'];
				$event['id'] 			= $event['guid'];
				$event['start_time'] 	= strftime('%H:%M %p', 	strtotime($event['start_date']) );
				$event['end_time'] 		= strftime('%H:%M %p', 	strtotime($event['end_date']) );
				$event['start_date'] 	= strftime('%A, %B %d, %Y', strtotime($event['start_date']));
				$event['end_date'] 		= strftime('%A, %B %d, %Y', strtotime($event['end_date']));
				$event['attendee_limit'] = $event['max_attendees'];
				$event['num_registered_attendees'] = $event['num_attendees'];
				$newevents[$key] = $event;
			}
		}
		$smarty->assign("events",$newevents);
		$smarty->assign("orderFields",$params['fields']);
		$smarty->assign("registerbtn",$params['registerbtn']);
		// Event field aliases
		$plugin_folder = substr(dirname(plugin_basename(__FILE__)),0,strpos(dirname(plugin_basename(__FILE__)),"/"));
		$smarty->display("wp-content/plugins/".$plugin_folder."/templates/iteration-template.tpl");
		return $output;
	}

	private function DatesListTemp($events,$params){
		$output = "";
		if(isset($params['registerbtn'])) $button = $params['registerbtn']; else $button = "Register";
		if(isset($params['soldoutmessage'])) $soldoutmessage = $params['soldoutmessage']; else $soldoutmessage = "Sold Out";

		if(!empty($events)){
			foreach($events as $i=>$event)
			{
				if($i >= $params['limit'] && is_numeric($params['limit'])) return $output;
				if(in_array($params['status'],array('tba','TBA'))) 
					$strdate = $params['tbamessage'];
				else if(array_key_exists('enddate',$params))
					$strdate =  strftime($params['dateformat'], strtotime($event['start_date'])).'</b> - <b>'.strftime($params['dateformat'], strtotime($event['end_date']));
				else
					$strdate = strftime('%a %b %d', strtotime($event['start_date']));
				if(strpos($params['hidefield'],'date') === false )
					$output .= "<b>".$strdate."</b>";
				if(strpos($params['hidefield'],'title') === false )
					$output .= " - ".$event['title'];
				if(!empty($event['venue_name'])) $output .= " - ".$event['venue_name'];
				
				if ( empty($params['eventfullurl']) && $event['soldOut'] == 1 ) $output .= " - <span class='ds-soldout-message'>".$soldoutmessage."</span>"; else $output .= " - <a href=\"".$event['url']."\">".$button."</a>";
				$output .= "<br><br>";
			}
		}
		
		return $output;
	}

	private function RadioListTemp($events,$params){
		$output = "";
		if(isset($params['registerbtn'])) $button = $params['registerbtn']; else $button = "Register";

		$radioName = $params['eventdateidname'];
		$radioContainerClass = "ds-radio-container ".$radioClass;
		$radioClass = "ds-radio-input ".$radioClass;

		foreach($events as $i=>$event)
		{
			if( $i >= $params['limit'] && is_numeric( $params['limit'] ) ) return $output;

			$radioIdName = "radioEventDateId_".$event['guid'];

			$output .= "<div class='".$radioContainerClass."' ".$containerStyle.">";
			$output .= "<input type='radio' class='".$radioClass."' ".$radioStyle." id='".$radioIdName."' name='".$radioName."' value='".$event['guid']."' />";
			$output .= "<label for='".$radioIdName."'>";

			$fields = "dates, - ,venue";
			$fields = explode(',',$fields);

			foreach($fields as $field){
				switch($field){
					case "event_title":
					case "event_name":
					case "title":
						$output .= $event['title'];
						break;
					case "startdate":
					case "start_date":
						$output .= $event['s_date'];
						break;
					case "enddate":
					case "end_date":
						$output .= $event['e_date'];
						break;
					case "starttime":
					case "start_time":
						$output .= $event['s_time'];
						break;
					case "endtime":
					case "end_time":
						$output .= $event['e_time'];
						break;
					case "starttime":
					case "start_time":
						$output .= $event['s_time'];
						break;
					case "date":
					case "dates":
						$output .= $event['s_date'].' @ '.$event['s_time'].' - '.$event['e_time'];
						break;
					case "venue":
					case "venuename":
					case "venue_name":
						$output .= $event['venue_name'];
						break;
					default:
						$output .= $field;
						break;
				}
			}
			$output .= '</label>';
			
			$output .= "</div>";
		}
		return $output;
	}

	private function TableTemp($events,$params){
		$output = "";
		if(isset($params['registerbtn'])) $button = $params['registerbtn']; else $button = "Register";
		$header = $params['header'];

		if(is_array($events)){
			if( count($events)){
				$titlesort = ' data-sort-initial="true"';
				$datesort = '';
				if(is_numeric($params['perpage'])) $perpage = $params['perpage']; else $perpage = 10;
				if($params['sortby'] == 'date'){ $datesort = $titlesort; $titlesort = ''; }

				$output .= '<table class="dynamicsync-table footable" data-page-size="'.$perpage.'">
							  <thead>
								<tr>';
				if(strpos($params['hidefield'],'title') === false )
					$output .= '<th class="dynamicsync-table-header" data-toggle="true"'.$titlesort.'>
							    '.$header['title'].'
							  </th>';
				if(true){
					$output .= '<th class="dynamicsync-table-header"';
								if(strpos($params['hidefield'],'title') !== false ) $output .= ' data-toggle="true"'; else $output .= ' data-hide="xsmall,phone"';
					$output .= $datesort.'>
							    '.$header['date'].'
							  </th>';
				}
				if(strpos($params['hidefield'],'time') === false )
					$output .= '<th class="dynamicsync-table-header" data-hide="xsmall,phone">
							    '.$header['time'].'
							  </th>';
				if(strpos($params['hidefield'],'venue') === false )
					$output .= '<th class="dynamicsync-table-header" data-hide="xsmall,phone,small">
							    '.$header['venue'].'
							  </th>';
				$output .= '<th class="dynamicsync-table-header" data-hide="xsmall,phone" data-sort-ignore="true">

							  </th>
							</tr>
						  </thead>
						<tbody>';

				foreach($events as $key=>$event){

					if(in_array($params['status'],array('tba','TBA'))){
						$strDate = "TBA";
						$strTime = "TBA";
					}
					else{
						if($event['s_date'] == $event['e_date']) $strDate = $event['s_date']; else $strDate = $event['s_date'].' &dash; '.$event['e_date'];
						if($event['pretty_time'] != '') $strTime = $event['pretty_time']; else $strTime = $event['s_time'].' &dash; '.$event['e_time'];
					}
					
					if(empty($params['eventfullurl']) && $event['soldOut'] == 1)
						$strRegister = '<span>Sold Out</span>';
					else
						$strRegister = '<a class="dynamicsync-table-button" href="'.$event['url'].'">'.$button.'</a>';

					$output .= '<tr class="dynamicsync-table-row">';

					if(strpos($params['hidefield'],'title') === false )
						$output .= '<td class="dynamicsync-table-cell">'.$event['title'].'</td>';
					if(strpos($params['hidefield'],'date') === false )
						$output .= '<td class="dynamicsync-table-cell" data-value="'.strtotime($event['start_date']).'">'.$strDate.'</td>';
					if(strpos($params['hidefield'],'time') === false )
						$output .= '<td class="dynamicsync-table-cell">'.$strTime.'</td>';
					if(strpos($params['hidefield'],'venue') === false )
						$output .= '<td class="dynamicsync-table-cell">'.$event['venue_name'].'</td>';
					$output .= '<td class="dynamicsync-table-cell">'.$strRegister.'</td>
								</tr>';
				}
						
				$output .= '</tbody>
								<tfoot class="dynamicsync-table-footer hide-if-no-paging">
								<tr>
									<td colspan="5">
										<div class="pagination pagination-centered"></div>
									</td>
								</tr>
							</tfoot>
						</table>';
			}
		}
		
		return $output;
	}

	private function eventDateTemp($eventType,$params,$settings){

		$output = "";
		//setlocale(LC_ALL, 'de_DE@euro', 'de_DE', 'deu_deu');
		if(isset($params['registerbtn'])) $button = $params['registerbtn']; else $button = "Register Now";


		if(is_array($eventType)){
			if(count($eventType)){
				foreach($eventType as $events ){
					$output .= '<form method="get" action="'.$events[0]['regFormUrl'].'" id="'.$events[0]['guid'].'">
						<input type="hidden" name="'.$settings->eventIdField.'" value="'.$events[0]['eventId'].'">
						<div class="ds-event-dates-container">
							<h2 class="ds-event-dates-title">'.$events[0]['eventTitle'].'</h2>
							<div class="col-md-9">
								<div class="col-md-2">';
					if($events[0]['isImage'])
						$output .= '<img style="width: 100%;" src="'.$events[0]['user1'].'"><br /><br />';
					if(!empty($event[0]['description']))
						$output .= '<span class="ds-event-dates-description">'.$events[0]['description'].'</span><br>';
					if(!empty($events[0]['price']))
						$output .= '<h5  class="ds-event-dates-price"><strong>Price:</strong> '.$events[0]['price'].'</h5><br />';
					
					$output .= '</div>
								<div class="col-md-7">';
					if(count($events) > 1){
						$output .= '<h4>Available Dates</h4>';
						foreach($events as $key=>$event)
						{
							$disabled = "";
							if($event['soldOut']) $disabled = "disabled";
							$output .= '<div style="width:290px;padding-bottom:20px;">';
							$output .= '<input id="'.$event['guid'].'_reg_link_'.$key.'" name="'.$settings->eventDateIdField.'" type="radio" value="'.$event['guid'].'" '.$disabled.'>';
							$output .= '<label for="'.$event['guid'].'_reg_link_'.$key.'"><div style="margin-top:-25px;margin-left: 25px;">';
							
							if($params['custom'] == 'title')
								$output .= '<h3 class="ds-event-date-title">'.$event['title'].'</h3>';

							$date = strftime ($params['dateformat'], strtotime($event['start_date']));
							
							if(!empty($event['pretty_time'])) 
								$time = $event['pretty_time'];
							else 
								$time = date('g:ia', strtotime($event['start_date']))." - ".date('g:ia', strtotime($event['end_date']));
							
							$output .= '<strong>';
							if($date != "") $output .= $date.'<br>';
							$output .= $time.'</strong><br>';
							
							if($event['soldOut']) {
								$output .= "<span class=\"ds-event-dates-sold-out-text\">SOLD OUT</span><br>";
							}
							
							if(!empty($event['description']))
								$output .= "<span class='ds-event-description'>".$event['description']."<br/></span>";
							if(!empty($event['venue_name'])) 
								$output .= $event['venue_name']."<br/>";
							if(!empty($event['venue_address']))
								$output .= $event['venue_address'];
							
							$output .= '</div></label></div>';
						}	// foreach
						$output .= "<button type='submit' class='ds-register-button' OnClick='return checkDateSelection(\"".$settings->eventDateIdField."\")'>".$button."</button>";
									
					}
					else{
						$event = $events[0];

						$output .= '<div style="width:290px;padding-bottom:20px;">';
						$output .= '<input type="hidden" value="'.$event['guid'].'" name="'.$settings->eventDateIdField.'">';

						if($params['custom'] == 'title')
							$output .= '<h3 class="ds-event-date-title">'.$event['title'].'</h3>';

						$date = strftime($params['dateformat'], strtotime($event['start_date']));
													
						if(in_array($params['status'],array("TBA",'tba'))){
							$output .= '<strong>'.$params['tbamessage'].'</strong><br>';
						}
						else{							
							if(!empty($event['pretty_time']))
							{
								$time = $event['pretty_time'];
							} else {
								$time = date('g:ia', strtotime($event['start_date']))." - ".date('g:ia', strtotime($event['end_date']));
							}

							$output .= '<strong>'.$date.'<br>'.$time.'</strong><br>';
						}
						if(!empty($event['description'])) {
							$output .= "<span class='ds-event-description'>".$event['description']."<br/></span>";
						}
						if(!empty($event['venue_name'])) {
							$output .= $event['venue_name']."<br/>";
						}
						if(!empty($event['venue_address'])) {
							$output .= $event['venue_address']."<br/>";
						}
						$output .= "</div>";
						if ( $event['soldOut'] )
							$output .= "<span class='ds-sold-out'>Sold Out</span>";
						else
							$output .= "<button class='ds-register-button' type='submit'>".$button."</button>";
										
					}
					$output .= '</div>		
							</div>
						</div>
					</form>';
				}
			}
		}
		return $output;
	}
}